diff --git a/bwb_tbl.c b/bwb_tbl.c
index 8484330..1d5b8ca 100644
--- a/bwb_tbl.c
+++ b/bwb_tbl.c
@@ -24,6 +24,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 
 #include "bwbasic.h"
@@ -71,6 +76,7 @@ struct bwb_command bwb_cmdtable[ COMMANDS ] =
       { CMD_DEFINT,       bwb_dint },
       { CMD_DEFSNG,       bwb_dsng },
       { CMD_DEFSTR,       bwb_dstr },
+      { CMD_MID,          bwb_mid }, /* Added this extension (JBV) */
 #if IMP_CMDCLS
       { CMD_CLS,          bwb_cls },
 #endif
@@ -120,6 +126,7 @@ struct bwb_command bwb_cmdtable[ COMMANDS ] =
       { CMD_RSET,         bwb_rset },
       { CMD_FIELD,        bwb_field },
       { CMD_LINE,         bwb_line },
+      { CMD_RENUM,        bwb_renum }, /* Added this extension (JBV) */
 #endif
 
       /* The remainder are the core functions defined for ANSI Minimal BASIC */
@@ -243,30 +250,31 @@ struct bwb_function bwb_prefuncs[ FUNCTIONS ] =
 
 struct bwb_op exp_ops[ N_OPERATORS ] =
    {
-   { "NOT",     OP_NOT,         12 },   /* multiple-character operators */
+   { "NOT",     OP_NOT,         2  },   /* multiple-character operators */
    { "AND",     OP_AND,         13 },   /* should be tested first because */
    { "OR",      OP_OR,          14 },   /* e.g. a ">=" would be matched */
    { "XOR",     OP_XOR,         15 },   /* as "=" if the single-character */
    { "IMP",     OP_IMPLIES,     16 },   /* operator came first */
    { "EQV",     OP_EQUIV,       17 },
-   { "MOD",     OP_MODULUS,     4  },
-   { "<>",      OP_NOTEQUAL,    7  },
-   { "<=",      OP_LTEQ,        10 },
-   { "=<",      OP_LTEQ,        10 },   /* allow either form */
-   { ">=",      OP_GTEQ,        11 },
-   { "=>",      OP_GTEQ,        11 },   /* allow either form */
-   { "<",       OP_LESSTHAN,    8  },
-   { ">",       OP_GREATERTHAN, 9  },
+   { "MOD",     OP_MODULUS,     5  },
+   { "<>",      OP_NOTEQUAL,    8  },
+   { "<=",      OP_LTEQ,        11 },
+   { "=<",      OP_LTEQ,        11 },   /* allow either form */
+   { ">=",      OP_GTEQ,        12 },
+   { "=>",      OP_GTEQ,        12 },   /* allow either form */
+   { "<",       OP_LESSTHAN,    9  },
+   { ">",       OP_GREATERTHAN, 10 },
    { "^",       OP_EXPONENT,    0  },
-   { "*",       OP_MULTIPLY,    2  },
-   { "/",       OP_DIVIDE,      2  },
-   { "\\",      OP_INTDIVISION, 3  },
-   { "+",       OP_ADD,         5  },
-   { "-",       OP_SUBTRACT,    5  },
-   { "=",       OP_EQUALS,      6  },
-   { "=",       OP_ASSIGN,      6  },   /* don't worry: OP_EQUALS will be converted to OP_ASSIGN if necessary */
-   { ";",       OP_STRJOIN,     18 },
-   { ",",       OP_STRTAB,      19 }
+   { "*",       OP_MULTIPLY,    3  },
+   { "/",       OP_DIVIDE,      3  },
+   { "\\",      OP_INTDIVISION, 4  },
+   { "+",       OP_ADD,         6  },
+   { "-",       OP_SUBTRACT,    6  },
+   { "=",       OP_EQUALS,      7  },
+   { "=",       OP_ASSIGN,      18 },   /* don't worry: OP_EQUALS will be converted to OP_ASSIGN if necessary */
+   { ";",       OP_STRJOIN,     19 },
+   { ",",       OP_STRTAB,      20 },
+   { "-",       OP_NEGATION,    1  }    /* Right below exponentiation (JBV) */
    };
 
 /* Error messages used more than once */
@@ -332,4 +340,3 @@ char *err_table[ N_ERRORS ] =
    };
 
 
-
\ No newline at end of file
diff --git a/bwb_var.c b/bwb_var.c
index fe56dc1..eddb92b 100644
--- a/bwb_var.c
+++ b/bwb_var.c
@@ -29,6 +29,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -162,6 +167,8 @@ bwb_erase( l )
    struct bwb_variable *v;
    struct bwb_variable *p;		/* previous variable in linked list */
    char tbuf[ MAXSTRINGSIZE + 1 ];
+   bstring *sp; /* JBV */
+   register int n; /* JBV */
 
    /* loop while arguments are available */
 
@@ -200,17 +207,39 @@ bwb_erase( l )
 
       /* deallocate memory */
 
-      free( v->array_sizes );
-      free( v->array_pos );
+      /* Revised to FREE pass-thru calls by JBV */
+      FREE( v->array_sizes, "bwb_erase" );
+      v->array_sizes = NULL; /* JBV */
+      FREE( v->array_pos , "bwb_erase");
+      v->array_pos = NULL; /* JBV */
       if ( v->type == NUMBER )
 	 {
-	 free( v->memnum );
+         /* Revised to FREE pass-thru call by JBV */
+	 FREE( v->memnum, "bwb_erase" );
+	 v->memnum = NULL; /* JBV */
 	 }
       else
 	 {
-	 free( v->memstr );
+		/* Following section added by JBV */
+		sp = v->memstr;
+		for ( n = 0; n < (int) v->array_units; ++n )
+		{
+			if ( sp[ n ].sbuffer != NULL )
+			{
+                                /* Revised to FREE pass-thru call by JBV */
+				FREE( sp[ n ].sbuffer, "bwb_erase" );
+				sp[ n ].sbuffer = NULL;
+			}
+			sp[ n ].rab = FALSE;
+			sp[ n ].length = 0;
+		}
+         /* Revised to FREE pass-thru call by JBV */
+	 FREE( v->memstr, "bwb_erase" );
+	 v->memstr = NULL; /* JBV */
 	 }
-      free( v );
+      /* Revised to FREE pass-thru call by JBV */
+      FREE( v, "bwb_erase" );
+      v = NULL; /* JBV */
 
       /* check for comma */
 
@@ -412,7 +441,8 @@ bwb_clear( l )
                   {
 		  if ( sp[ n ].sbuffer != NULL )
 		     {
-		     free( sp[ n ].sbuffer );
+                     /* Revised to FREE pass-thru call by JBV */
+		     FREE( sp[ n ].sbuffer, "bwb_clear" );
 		     sp[ n ].sbuffer = NULL;
                      }
                   sp[ n ].rab = FALSE;
@@ -447,6 +477,8 @@ var_delcvars()
    {
    struct bwb_variable *v;
    struct bwb_variable *p;		/* previous variable */
+   bstring *sp; /* JBV */
+   register int n; /* JBV */
 
    p = &CURTASK var_start;
    for ( v = CURTASK var_start.next; v != &CURTASK var_end; v = v->next )
@@ -462,15 +494,35 @@ var_delcvars()
 
             /* deallocate memory */
 
-            free( v->array_sizes );
-            free( v->array_pos );
+            /* Revised to FREE pass-thru calls by JBV */
+            FREE( v->array_sizes, "var_delcvars" );
+            v->array_sizes = NULL; /* JBV */
+            FREE( v->array_pos, "var_delcvars" );
+            v->array_pos = NULL; /* JBV */
 	    if ( v->type == NUMBER )
 	       {
-	       free( v->memnum );
+               /* Revised to FREE pass-thru call by JBV */
+	       FREE( v->memnum, "var_delcvars" );
+	       v->memnum = NULL; /* JBV */
 	       }
 	    else
 	       {
-	       free( v->memstr );
+		/* Following section added by JBV */
+		sp = v->memstr;
+		for ( n = 0; n < (int) v->array_units; ++n )
+		{
+			if ( sp[ n ].sbuffer != NULL )
+			{
+                                /* Revised to FREE pass-thru call by JBV */
+				FREE( sp[ n ].sbuffer, "var_delcvars" );
+				sp[ n ].sbuffer = NULL;
+			}
+			sp[ n ].rab = FALSE;
+			sp[ n ].length = 0;
+		}
+               /* Revised to FREE pass-thru call by JBV */
+	       FREE( v->memstr, "var_delcvars" );
+	       v->memstr = NULL; /* JBV */
 	       }
             }
 
@@ -480,7 +532,9 @@ var_delcvars()
 
          /* deallocate the variable itself */
 
-         free( v );
+         /* Revised to FREE pass-thru call by JBV */
+         FREE( v, "var_delcvars" );
+         v = NULL; /* JBV */
 
          }
 
@@ -617,6 +671,246 @@ bwb_dstr( l )
 
 /***********************************************************
 
+        FUNCTION:	bwb_mid()
+
+	DESCRIPTION:    This function implements the BASIC
+			MID$ command.
+
+			Same as MID$ function, except it will set
+			the desired substring and not return its
+			value.  Added by JBV 10/95
+
+	SYNTAX:		MID$( string-variable$, start-position-in-string
+			[, number-of-spaces ] ) = expression
+
+***********************************************************/
+
+#if ANSI_C
+struct bwb_line *
+bwb_mid( struct bwb_line *l )
+#else
+struct bwb_line *
+bwb_mid( l )
+   struct bwb_line *l;
+#endif
+   {
+   char tbuf[ MAXSTRINGSIZE + 1 ];
+   char source_string[ MAXSTRINGSIZE + 1 ];
+   struct bwb_variable *v;
+   static int pos;
+   bstring *d;
+   int *pp;
+   int n_params;
+   int p;
+   register int n;
+   int startpos, numchars, endpos;
+   int source_counter, source_length, target_length;
+   int target_terminate;
+   struct exp_ese *e;
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in bwb_mid(): MID$ command" );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   /* Get past left parenthesis */
+   adv_ws( l->buffer, &( l->position ) );
+   ++( l->position );
+   adv_ws( l->buffer, &( l->position ) );
+
+   /* Get variable name and find variable */
+   bwb_getvarname( l->buffer, tbuf, &( l->position ) );
+   v = var_find( tbuf );
+   if ( v == NULL )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): failed to find variable" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( err_syntax );
+#endif
+      }
+
+   if ( v->type != STRING )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): assignment must be to string variable" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( err_syntax );
+#endif
+      }
+
+   /* read subscripts */
+   pos = 0;
+   if ( ( v->dimensions == 1 ) && ( v->array_sizes[ 0 ] == 1 ))
+      {
+#if INTENSIVE_DEBUG
+      sprintf( bwb_ebuf, "in bwb_mid(): variable <%s> has 1 dimension",
+         v->name );
+     bwb_debug( bwb_ebuf );
+#endif
+      n_params = 1;
+      pp = &p;
+      pp[ 0 ] = dim_base;
+      }
+   else
+      {
+#if INTENSIVE_DEBUG
+      sprintf( bwb_ebuf, "in bwb_mid(): variable <%s> has > 1 dimensions",
+         v->name );
+      bwb_debug( bwb_ebuf );
+#endif
+      dim_getparams( l->buffer, &( l->position ), &n_params, &pp );
+      }
+
+   CURTASK exps[ CURTASK expsc ].pos_adv = pos;
+   for ( n = 0; n < v->dimensions; ++n )
+      {
+      v->array_pos[ n ] = pp[ n ];
+      }
+
+   /* get bstring pointer */
+   d = var_findsval( v, pp );
+
+   /* Get past next comma and white space */
+   adv_ws( l->buffer, &( l->position ) );
+   ++( l->position );
+   adv_ws( l->buffer, &( l->position ) );
+
+   /* Get starting position (expression) */
+   adv_element( l->buffer, &( l->position ), tbuf );
+   pos = 0;
+   e = bwb_exp( tbuf, FALSE, &pos );
+   startpos = (int) exp_getnval( e );
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in bwb_mid(): startpos <%d> buffer <%lX>",
+      startpos, (long) d->sbuffer );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   /* Get past next comma and white space (if they exist) */
+   adv_ws( l->buffer, &( l->position ) );
+   if (l->buffer[l->position] == ',')
+      {
+      target_terminate = 0;
+      ++( l->position );
+      adv_ws( l->buffer, &( l->position ) );
+      adv_element( l->buffer, &( l->position ), tbuf );
+      pos = 0;
+      e = bwb_exp( tbuf, FALSE, &pos );
+      numchars = (int) exp_getnval( e );
+      if ( numchars == 0 )
+         {
+#if PROG_ERRORS
+         sprintf( bwb_ebuf, "in bwb_mid(): destination string no. of chars out of range" );
+         bwb_error( bwb_ebuf );
+#else
+         bwb_error( "Argument out of range" );
+#endif
+         }
+      }
+   else
+      {
+      target_terminate = 1;
+      numchars = 0;
+      }
+
+   if ( numchars < 0 )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): negative string length" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( "Negative string length" );
+#endif
+      }
+
+#if INTENSIVE_DEBUG
+   sprintf( bwb_ebuf, "in bwb_mid(): numchars <%d> target_terminate <%d>", numchars, target_terminate );
+   bwb_debug( bwb_ebuf );
+#endif
+
+   /* Get past equal sign */
+   adv_ws( l->buffer, &( l->position ) );
+   if (l->buffer[l->position] == ')')
+      {
+      ++(l->position);
+      adv_ws( l->buffer, &( l->position ) );
+      }
+   ++(l->position);
+   adv_ws( l->buffer, &( l->position ) );
+
+   /* Evaluate string expression */
+   e = bwb_exp( l->buffer, FALSE, &( l->position ) );
+   if ( e->type != STRING )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): assignment must be from string expression" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( err_syntax );
+#endif
+      }
+
+   /* Prepare to MID the string */
+   str_btoc( source_string, exp_getsval( e ) );
+   str_btoc( tbuf, d );
+   target_length = strlen( tbuf );
+   if ( startpos > ( target_length + 1 ) )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): non-contiguous string created" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( "Non-contiguous string created" );
+#endif
+      }
+
+   if ( startpos < 1 )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_mid(): destination string start position out of range" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( "Argument out of range" );
+#endif
+      }
+
+   source_length = strlen( source_string );
+   if ( numchars == 0 ) numchars = source_length;
+   endpos = startpos + numchars - 1;
+
+   /* MID the string */
+   if ( endpos < startpos ) tbuf[ startpos - 1 ] = '\0';
+   else
+      {
+      source_counter = 0;
+      for ( n = startpos - 1; n < endpos; ++n )
+         {
+         if ( source_counter < source_length )
+            tbuf[ n ] = source_string[ source_counter ];
+         else
+            tbuf[ n ] = ' ';
+         ++source_counter;
+         }
+      /* Terminate if indicated or characters were added */
+      if ( ( endpos > target_length ) || ( target_terminate == 1 ) )
+         tbuf[ endpos ] = '\0';
+      }
+   str_ctob( d, tbuf );
+
+#if MULTISEG_LINES
+   adv_eos( l->buffer, &( l->position ));
+#endif
+
+   return bwb_zline( l );
+
+   }
+
+/***********************************************************
+
         Function:	var_defx()
 
 	DESCRIPTION:    This function is a generalized DEFxxx handler.
@@ -886,6 +1180,7 @@ bwb_getvarname( lb, sb, n )
          case ';':
          case '(':              /* beginning of parameter list for dimensioned array */
          case '+':              /* add variables */
+         case '=':              /* Don't forget this one (JBV) */
             sb[ s ] = 0;
             return TRUE;
          default:
@@ -1029,7 +1324,8 @@ var_new( name )
 
    /* get memory for new variable */
 
-   if ( ( v = (struct bwb_variable *) calloc( 1, sizeof( struct bwb_variable ) ))
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( v = (struct bwb_variable *) CALLOC( 1, sizeof( struct bwb_variable ), "var_new" ))
       == NULL )
       {
       bwb_error( err_getmem );
@@ -1299,7 +1595,8 @@ bwb_dim( l )
 
          /* assign memory for parameters */
 
-         if ( ( newvar->array_sizes = (int *) calloc( n_params, sizeof( int )  )) == NULL )
+         /* Revised to CALLOC pass-thru call by JBV */
+         if ( ( newvar->array_sizes = (int *) CALLOC( n_params, sizeof( int ), "bwb_dim"  )) == NULL )
             {
 #if PROG_ERRORS
             sprintf( bwb_ebuf, "in line %d: Failed to find memory for array_sizes for <%s>",
@@ -1323,7 +1620,8 @@ bwb_dim( l )
 
          /* assign memory for current position */
 
-         if ( ( newvar->array_pos = (int *) calloc( n_params, sizeof( int ) )) == NULL )
+         /* Revised to CALLOC pass-thru call by JBV */
+         if ( ( newvar->array_pos = (int *) CALLOC( n_params, sizeof( int ), "bwb_dim" )) == NULL )
             {
 #if PROG_ERRORS
             sprintf( bwb_ebuf, "in line %d: Failed to find memory for array_pos for <%s>",
@@ -1364,8 +1662,13 @@ bwb_dim( l )
         	  (long) ( newvar->array_units + 1 ) * sizeof( bstring ));
                bwb_debug( bwb_ebuf );
 #endif
-	       if ( ( newvar->memnum = calloc( newvar->array_units, sizeof( bstring) )) == NULL )
-		  {
+               /*------------------------------------------------------*/
+               /* memnum, not memstr, was used here -- incorrect (JBV) */
+               /* Revised to CALLOC pass-thru call by JBV              */
+               /*------------------------------------------------------*/
+               if ( ( newvar->memstr = (bstring *)
+                  CALLOC( newvar->array_units, sizeof( bstring), "bwb_dim" )) == NULL )
+               {
 #if PROG_ERRORS
                   sprintf( bwb_ebuf, "in line %d: Failed to find memory for array <%s>",
                      l->number, newvar->name );
@@ -1385,8 +1688,10 @@ bwb_dim( l )
         	  (long) ( newvar->array_units + 1 ) * sizeof( double ));
                bwb_debug( bwb_ebuf );
 #endif
+
+               /* Revised to CALLOC pass-thru call by JBV */
                if ( ( np = (bnumber *)
-                  calloc( newvar->array_units, sizeof( bnumber ) )) == NULL )
+                  CALLOC( newvar->array_units, sizeof( bnumber ), "bwb_dim" )) == NULL )
                   {
 #if PROG_ERRORS
                   sprintf( bwb_ebuf, "in line %d: Failed to find memory for array <%s>",
@@ -1544,6 +1849,9 @@ dim_getparams( buffer, pos, n_params, pp )
    int x_pos, s_pos;
    struct exp_ese *e;
    char tbuf[ MAXSTRINGSIZE + 1 ];
+#if INTENSIVE_DEBUG
+   register int n;
+#endif
 
    /* set initial values */
 
@@ -1825,8 +2133,7 @@ var_findnval( v, pp )
    for ( n = 0; n < v->dimensions; ++n )
       {
       sprintf( bwb_ebuf,
-	 "in var_findnval(): dimensioned variable <%s> pos <%d> <%d>.",
-	 v->name,
+         "in var_findnval(): dimensioned variable pos <%d> <%d>.",
          n, pp[ n ] );
       bwb_debug( bwb_ebuf );
       }
@@ -1864,6 +2171,8 @@ var_findsval( v, pp )
    bstring *p;
 
 #if INTENSIVE_DEBUG
+   register int n;
+
    sprintf( bwb_ebuf, "in var_findsval(): entered, var <%s>", v->name );
    bwb_debug( bwb_ebuf );
 #endif
@@ -2014,6 +2323,8 @@ var_make( v, type )
    {
    size_t data_size;
    bstring *b;
+   bstring *sp; /* JBV */
+   register int n; /* JBV */
 #if TEST_BSTRING
    static int tnumber = 0;
 #endif
@@ -2032,9 +2343,48 @@ var_make( v, type )
 
    /* get memory for array */
 
+   /* First kleanup the joint (JBV) */
+   if (v->memnum != NULL)
+   {
+       /* Revised to FREE pass-thru call by JBV */
+       FREE(v->memnum, "var_make");
+       v->memnum = NULL;
+   }
+   if (v->memstr != NULL)
+   {
+       /* Remember to deallocate those far-flung branches! (JBV) */
+       sp = v->memstr;
+       for ( n = 0; n < (int) v->array_units; ++n )
+       {
+           if ( sp[ n ].sbuffer != NULL )
+           {
+               /* Revised to FREE pass-thru call by JBV */
+               FREE( sp[ n ].sbuffer, "var_make" );
+               sp[ n ].sbuffer = NULL;
+           }
+           sp[ n ].rab = FALSE;
+           sp[ n ].length = 0;
+       }
+       /* Revised to FREE pass-thru call by JBV */
+       FREE(v->memstr, "var_make");
+       v->memstr = NULL;
+   }
+   /* Revised to FREE pass-thru calls by JBV */
+   if (v->array_sizes != NULL)
+   {
+       FREE(v->array_sizes, "var_make");
+       v->array_sizes = NULL; /* JBV */
+   }
+   if (v->array_pos != NULL)
+   {
+       FREE(v->array_pos, "var_make");
+       v->array_pos = NULL; /* JBV */
+   }
+
    if ( v->type == NUMBER )
       {
-      if ( ( v->memnum = calloc( 2, sizeof( bnumber ) )) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( v->memnum = CALLOC( 2, sizeof( bnumber ), "var_make" )) == NULL )
 	 {
 	 bwb_error( err_getmem );
 	 return FALSE;
@@ -2042,7 +2392,8 @@ var_make( v, type )
       }
    else
       {
-      if ( ( v->memstr = calloc( 2, sizeof( bstring ) )) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( v->memstr = CALLOC( 2, sizeof( bstring ), "var_make" )) == NULL )
 	 {
 	 bwb_error( err_getmem );
 	 return FALSE;
@@ -2051,13 +2402,15 @@ var_make( v, type )
 
    /* get memory for array_sizes and array_pos */
 
-   if ( ( v->array_sizes = (int *) calloc( 2, sizeof( int ) )) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( v->array_sizes = (int *) CALLOC( 2, sizeof( int ), "var_make" )) == NULL )
       {
       bwb_error( err_getmem );
       return FALSE;
       }
 
-   if ( ( v->array_pos = (int *) calloc( 2, sizeof( int ) )) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( v->array_pos = (int *) CALLOC( 2, sizeof( int ), "var_make" )) == NULL )
       {
       bwb_error( err_getmem );
       return FALSE;
diff --git a/bwbasic.c b/bwbasic.c
index 2e2cde5..5c4f37e 100644
--- a/bwbasic.c
+++ b/bwbasic.c
@@ -28,6 +28,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <ctype.h>
 #include <math.h>
@@ -153,7 +158,8 @@ bwb_init( argc, argv )
    /* Memory allocation */
    /* eXecute TeXT stack */
 
-   if ( ( xtxts = calloc( XTXTSTACKSIZE, sizeof( struct xtxtsl ) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( xtxts = CALLOC( XTXTSTACKSIZE, sizeof( struct xtxtsl ), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for xtxts" );
@@ -164,7 +170,8 @@ bwb_init( argc, argv )
 
    /* expression stack */
 
-   if ( ( exps = calloc( ESTACKSIZE, sizeof( struct exp_ese ) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( exps = CALLOC( ESTACKSIZE, sizeof( struct exp_ese ), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for exps" );
@@ -175,7 +182,8 @@ bwb_init( argc, argv )
 
    /* EXEC stack */
 
-   if ( ( excs = calloc( EXECLEVELS, sizeof( struct exse ) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( excs = CALLOC( EXECLEVELS, sizeof( struct exse ), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for excs" );
@@ -197,8 +205,8 @@ bwb_init( argc, argv )
    exsc = -1;
    expsc = 0;
    xtxtsc = 0;
-   bwb_start.position = 1;
-   bwb_l = &bwb_start;
+   bwb_start.position = 0;
+   bwb_l = &bwb_start; 
 
    var_init( 0 );
    fnc_init( 0 );
@@ -208,7 +216,8 @@ bwb_init( argc, argv )
 
    /* character buffers */
 
-   if ( ( bwb_ebuf = calloc( MAXSTRINGSIZE + 1, sizeof(char) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( bwb_ebuf = CALLOC( MAXSTRINGSIZE + 1, sizeof(char), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for bwb_ebuf" );
@@ -216,7 +225,8 @@ bwb_init( argc, argv )
       bwb_error( err_getmem );
 #endif
       }
-   if ( ( read_line = calloc( MAXREADLINESIZE + 1, sizeof(char) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( read_line = CALLOC( MAXREADLINESIZE + 1, sizeof(char), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for read_line" );
@@ -248,7 +258,8 @@ bwb_init( argc, argv )
    /* assign memory for the device table */
 
 #if COMMON_CMDS
-   if ( ( dev_table = calloc( DEF_DEVICES, sizeof( struct dev_element ) ) ) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( dev_table = CALLOC( DEF_DEVICES, sizeof( struct dev_element ), "bwb_init") ) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_init(): failed to find memory for dev_table" );
@@ -399,9 +410,9 @@ bwb_init( argc, argv )
    ++program_run;
    if (( argc > 1 ) && ( program_run == 1 ))
       {
-      if ( ( input = fopen( argv[ 1 ], "r" )) == NULL )
+      strcpy( CURTASK progfile, argv[ 1 ] ); /* JBV */
+      if ( ( input = fopen( CURTASK progfile, "r" )) == NULL ) /* JBV */
          {
-         strcpy( CURTASK progfile, argv[ 1 ] );
          strcat( CURTASK progfile, ".bas" );
          if ( ( input = fopen( CURTASK progfile, "r" )) == NULL )
             {
@@ -412,7 +423,7 @@ bwb_init( argc, argv )
          }
       if ( input != NULL )
          {
-         strcpy( CURTASK progfile, argv[ 1 ] );
+         /* strcpy( CURTASK progfile, argv[ 1 ] ); */  /* Removed by JBV */
 #if INTENSIVE_DEBUG
          sprintf( bwb_ebuf, "in main(): progfile is <%s>.", CURTASK progfile );
          bwb_debug( bwb_ebuf );
@@ -442,6 +453,7 @@ bwb_interact( void )
 bwb_interact()
 #endif
    {
+   char tbuf[ MAXSTRINGSIZE + 1 ]; /* JBV */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_interact(): ready to read from keyboard" );
@@ -451,6 +463,7 @@ bwb_interact()
    /* take input from keyboard */
 
    bwb_gets( read_line );
+   bwb_stripcr( read_line ); /* JBV */
 
    /* If there is no line number, execute the line as received */
 
@@ -459,6 +472,17 @@ bwb_interact()
       bwb_xtxtline( read_line );
       }
 
+   /*-----------------------------------------------------------------*/
+   /* Another possibility: if read_line is a numeric constant, delete */
+   /* the indicated line number (JBV)                                 */
+   /*-----------------------------------------------------------------*/
+   else if ( is_numconst( read_line ) == TRUE )
+   {
+       strcpy(tbuf, read_line);
+       sprintf(read_line, "delete %s\0", tbuf);
+       bwb_xtxtline( read_line );
+   }
+
    /* If there is a line number, add the line to the file in memory */
 
    else
@@ -553,7 +577,9 @@ bwb_ladd( buffer, replace )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( s_buffer = calloc( (size_t) MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( s_buffer = CALLOC( (size_t) MAXSTRINGSIZE + 1, sizeof( char ), "bwb_ladd" )) == NULL )
 	 {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_ladd(): failed to find memory for s_buffer" );
@@ -571,7 +597,8 @@ bwb_ladd( buffer, replace )
 
    /* get memory for this line */
 
-   if ( ( l = (struct bwb_line *) calloc( (size_t) 1, sizeof( struct bwb_line ) )) == NULL )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( l = (struct bwb_line *) CALLOC( (size_t) 1, sizeof( struct bwb_line ), "bwb_ladd")) == NULL )
       {
 #if PROG_ERRORS
       bwb_error( "in bwb_ladd(): failed to find memory for new line" );
@@ -648,7 +675,7 @@ bwb_ladd( buffer, replace )
 
       /* replace a previously existing line */
 
-      if ( ( l->xnum == TRUE )
+      if ( ( l->xnum == (char) TRUE ) /* Better recast this one (JBV) */
          && ( previous->number == l->number )
 	 && ( replace == TRUE )
 	 )
@@ -666,7 +693,10 @@ bwb_ladd( buffer, replace )
 
          /* free the current line */
 
-         free( l );
+         /* Revised to FREE pass-thru calls by JBV */
+         /* if (l->buffer != NULL) FREE( l->buffer, "bwb_ladd" ); */
+         /* FREE( l, "bwb_ladd" ); */
+         bwb_freeline( l ); /* JBV */
 
          /* and return */
 
@@ -724,8 +754,10 @@ bwb_ladd( buffer, replace )
 
    /* attempt to link line number has failed; free memory */
 
-   free( l->buffer );
-   free( l );
+   /* Revised to FREE pass-thru calls by JBV */
+   /* if (l->buffer != NULL) FREE( l->buffer, "bwb_ladd" ); */
+   /* FREE( l, "bwb_ladd" ); */
+   bwb_freeline( l ); /* JBV */
 
    sprintf( bwb_ebuf, ERR_LINENO );
    bwb_error( bwb_ebuf );
@@ -810,14 +842,16 @@ bwb_xtxtline( buffer )
    bwb_debug( bwb_ebuf );
 #endif
 
-   if ( CURTASK xtxts[ CURTASK xtxtsc ].l.buffer != NULL )
-      {
-#if INTENSIVE_DEBUG
-      sprintf( bwb_ebuf, "in bwb_xtxtline(): freeing buffer memory" );
-      bwb_debug( bwb_ebuf );
-#endif
-      free( CURTASK xtxts[ CURTASK xtxtsc ].l.buffer );
-      }
+/* Removed by JBV (no longer needed, done by ln_asbuf) */
+/*   if ( CURTASK xtxts[ CURTASK xtxtsc ].l.buffer != NULL )
+      { */
+/* #if INTENSIVE_DEBUG */
+/*      sprintf( bwb_ebuf, "in bwb_xtxtline(): freeing buffer memory" );
+      bwb_debug( bwb_ebuf ); */
+/* #endif */
+        /* Revised to FREE pass-thru call by JBV */
+/*      FREE( CURTASK xtxts[ CURTASK xtxtsc ].l.buffer, "bwb_xtxtline" );
+      } */
 
    /* copy the whole line to the line structure buffer */
 
@@ -938,8 +972,10 @@ bwb_decexec()
    if ( CURTASK excs[ CURTASK exsc ].code == EXEC_ON )
       {
 
-      free( CURTASK excs[ CURTASK exsc ].while_line->buffer );
-      free( CURTASK excs[ CURTASK exsc ].while_line );
+      /* Revised to FREE pass-thru calls by JBV */
+      /* FREE( CURTASK excs[ CURTASK exsc ].while_line->buffer, "bwb_decexec" ); */
+      /* FREE( CURTASK excs[ CURTASK exsc ].while_line, "bwb_decexec" ); */
+      bwb_freeline( CURTASK excs[ CURTASK exsc ].while_line ); /* JBV */
 
       bwb_decexec();
       }
@@ -1236,14 +1272,18 @@ ln_asbuf( l, s )
 #endif
    {
 
-#if DONTDOTHIS			/* but why not? */
+/* Reinstated by JBV */
+/* #if DONTDOTHIS */		/* but why not? */
    if ( l->buffer != NULL )
       {
-      free( l->buffer );
+      /* Revised to FREE pass-thru call by JBV */
+      FREE( l->buffer, "ln_asbuf" );
+      l->buffer = NULL; /* JBV */
       }
-#endif
+/* #endif */
 
-   if ( ( l->buffer = calloc( strlen( s ) + 2, sizeof( char ) ) )
+   /* Revised to CALLOC pass-thru call by JBV */
+   if ( ( l->buffer = CALLOC( strlen( s ) + 2, sizeof( char ), "ln_asbuf") )
       == NULL )
       {
 #if PROG_ERRORS
@@ -1341,7 +1381,9 @@ break_mes( x )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( tmp_buffer = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( tmp_buffer = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "break_mes")) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in break_mes(): failed to find memory for tmp_buffer" );
@@ -1448,3 +1490,50 @@ is_ln( buffer )
    }
 
 
+/***************************************************************
+
+	FUNCTION:       CALLOC()
+
+	DESCRIPTION:    Pass-thru function to calloc() for debugging
+			purposes.  Added by JBV 10/95
+
+***************************************************************/
+
+void *
+#if ANSI_C
+CALLOC( size_t nelem, size_t elsize, char *str )
+#else
+CALLOC( nelem, elsize, str )
+   size_t nelem;
+   size_t elsize;
+   char *str;
+#endif
+{
+    void *ptr;
+
+    ptr = calloc(nelem, elsize);
+    /* printf("%x %x\n", ptr, mallocblksize(ptr)); */
+    return ptr;
+}
+
+/***************************************************************
+
+	FUNCTION:       FREE()
+
+	DESCRIPTION:    Pass-thru function to free() for debugging
+			purposes.  Added by JBV 10/95
+
+***************************************************************/
+
+void
+#if ANSI_C
+FREE( void *ptr, char *str )
+#else
+FREE( ptr, str )
+   void *ptr;
+   char *str;
+#endif
+{
+    /* printf("%x\n", ptr); */
+    free(ptr);
+}
